do
local oldUnit = Unit
Unit = Class(oldUnit) {
    OnCreate = function(self)
        oldUnit.OnCreate(self)
		self.VeteranTracker = 0
	end,
	
    OnKilledUnit = function(self, unitKilled)
		local deadUnit = unitKilled:GetBlueprint().Categories
		for i, cat in deadUnit do
			if cat == 'EXPERIMENTAL' or cat == 'COMMAND' then
				self.VeteranTracker = self.VeteranTracker + 16
			elseif cat == 'TECH3' then
				self.VeteranTracker = self.VeteranTracker + 4
			elseif cat == 'TECH2' then
				self.VeteranTracker = self.VeteranTracker + 2
			elseif cat == 'TECH1' then
				self.VeteranTracker = self.VeteranTracker + 1
			end
		end
		self.Sync.VeteranTracker = self.VeteranTracker
		oldUnit.OnKilledUnit(self, unitKilled)
   end,

	CheckVeteranLevel = function(self)
        local bp = self:GetBlueprint().Veteran
        #There is no veteran block in the bp, return
        if not bp then
            bp = Game.VeteranDefault
        end
        #LOG('*DEBUG: Vet Table = ', repr(bp))
        #We add 1 because we get this before the stat gets updated
        local unitKills = self.VeteranTracker
        #LOG('*DEBUG: Veteran Kills = ', repr(unitKills))
        #We are already at the highest veteran level, return
        if self.VeteranLevel == table.getsize(bp) then
            return
        end

        local nextLvl = self.VeteranLevel + 1
        local nextKills = bp[('Level' .. nextLvl)]
        if unitKills >= nextKills then
            self:SetVeteranLevel(nextLvl)
        end
    end,
	
	SetVeteranLevel = function(self, level)
		oldUnit.SetVeteranLevel(self, level)
		self:CheckVeteranLevel()
	end,
}
end
